/***********************************************************************/
/*                                                                     */
/*  FILE        :mole.c                                                */
/*  DESCRIPTION :initialize and draw mole                              */
/*  CPU TYPE    :RX62N                                                 */
/*                                                                     */
/***********************************************************************/
#include <machine.h>
#include "iodefine.h"
#include "global_val.h"
#include "global_func.h"
#include "define_const.h"

// 100Hz^C}@ON
void initCMT1(void){
	CMT.CMSTR0.BIT.STR1 = 1;	//start
}

// ̏Ԃ̑JڎԂ_ɐݒ
void initMOLE(void){
	int i;
	unsigned char x,y;

	global_random_value[0]  = ((get_adc_x()) & 0x03);
	global_random_value[0] += ((get_adc_x()) & 0x03) << 2;
	global_random_value[0] += ((get_adc_x()) & 0x03) << 4;
	global_random_value[0] += ((get_adc_x()) & 0x03) << 6;

	for(i=1; i<255; i++){
		global_random_value[i] = (global_random_value[i-1]) + 47;
	}

}

// wiFƕ\ʒủn`
void initCOLOR(void){
	frct(0,0,319,239,COLOR_BASE,DRAW_MOV);
	frct(0,13,319,27,COLOR_WHITE,DRAW_MOV);
}

// \`
void initSTRING(void){
	draw_string("SCORE 000    PLEASE TOUCH PANEL",0,1);
}

// 炪gϐ̈
void reset_state(void){

	int i;
	unsigned short work_score;
	unsigned char buff[8] = {
		31, 248, 62, 155, 93, 186, 124, 217,
	};

	work_score = global_score = 0;
	global_time = 10;
		
	global_score_buff[0] = '0';
	global_score_buff[1] = '0';
	global_score_buff[2] = '0';
	global_score_buff[3] = '\0';

	initCOLOR();
	initSTRING();

	for(i=0; i<8; i++){
		mole[i].draw = 1;
		mole[i].state = 0;
		mole[i].time = buff[i];
		draw_default(i);
	}

	for(i=0; i<6; i++){
		mole[i].state = i;
		draw_mole(i);
		mole[i].state = 0;
	}

	while(global_touch);
	while(!global_touch);

	frct(100,13,319,27,COLOR_WHITE,DRAW_MOV);
	draw_time(global_time);
	initMOLE();
	initCMT1();
}

// Q[̌oߎԂo[Otŕ`
void draw_time(signed char time){
	signed char i;
	draw_string("TIME",15,1);
	for(i=20; i<30; i++){
		if((time - i) > -20)
			frct(FONT_WIDTH_X*i+1,14,FONT_WIDTH_X*(i+1)-1,27,COLOR_BLACK,DRAW_MOV);
		else
			frct(FONT_WIDTH_X*i+1,14,FONT_WIDTH_X*(i+1)-1,27,COLOR_WHITE,DRAW_MOV);
	}
}

// XRA`pf[^(10i1)ɕ
void make_score(unsigned short work_score){
	int i;
	for(i=2; i>=0; i--){
		global_score_buff[i] = (work_score % 10) + '0';
		work_score /= 10;
	}
}