/***********************************************************************/
/*                                                                     */
/*  FILE        :touch.c                                               */
/*  DESCRIPTION :check touch and position                              */
/*  CPU TYPE    :RX62N                                                 */
/*                                                                     */
/***********************************************************************/
#include "iodefine.h"
#include "touch.h"

extern int global_touch;

unsigned short global_inX;
unsigned short global_inY;
extern int X_MAX,X_MIN,Y_MAX,Y_MIN;

#define ADDRA ADDR0
#define ADDRB ADDR1

void init_touch(void)
{
	MSTP_S12AD = 0;		// enable S12AD@^b`ʒuo

	//for touch
	S12AD.ADCSR.BYTE = 0;				//	ADIE=0,1cycle scan

	PORT4.PODR.BYTE = (PORT4.PODR.BYTE & 0xf0) | T_idle_DR;
	PORT4.PDR.BYTE = (PORT4.PDR.BYTE & 0xf0) | T_idle_DDR;
	PORT4.PCR.BIT.B2 = 0;
}

// CMTU0_CMT0
//^b`pl̏擾@1msœ삷銄荞
void Excep_CMTU0_CMT0(void)
{ 
	static int t_state;

	switch(t_state){					//oNo.mF
	case 0:								//0F^b`ꂽo
		PORT4.PODR.BYTE = (PORT4.PODR.BYTE & 0xf0) | T_sense_DR;
		PORT4.PDR.BYTE = (PORT4.PDR.BYTE & 0xf0) | T_sense_DDR;
		PORT4.PCR.BIT.B2 = 1;
		t_state++;
		break;
	case 1:								//1F^b`Ă2
		if(PORT4.PIDR.BIT.B0 == ON){	
			t_state++;
		} else {						//@^b`ĂȂΌo0
			global_touch = 0;
			t_state = 0;
		}
		break;
	case 2:								//`^Ôߑ҂
	case 3:
		t_state++;
		break;
	case 4:								//4F^b`Ɣ
		if(PORT4.PIDR.BIT.B0 == ON){	
			PORT4.PODR.BYTE = (PORT4.PODR.BYTE & 0xf0) | T_posY_DR;	//yʒuopd
			PORT4.PDR.BYTE = (PORT4.PDR.BYTE & 0xf0) | T_posY_DDR;
			PORT4.PCR.BIT.B2 = 0;
			t_state++;
		} else {						//@^b`ȂȂ猟o0
			global_touch = 0;
			t_state = 0;
		}
		break;
	case 5:								//5FyôA-DRo[^N
		S12AD.ADANS0.WORD = 1;			//AN0 enable
		S12AD.ADCSR.BIT.ADST = 1;		//strat
		t_state++;
		break;
	case 6:								//6F^b`opd
		PORT4.PODR.BYTE = (PORT4.PODR.BYTE & 0xf0) | T_sense_DR;
		PORT4.PDR.BYTE = (PORT4.PDR.BYTE & 0xf0) | T_sense_DDR;
		PORT4.PCR.BIT.B2 = 1;
		t_state++;
		break;
	case 7:								//7F^b`Ɣ
		if(PORT4.PIDR.BIT.B0 == ON){	//
			PORT4.PODR.BYTE = (PORT4.PODR.BYTE & 0xf0) | T_posX_DR;	//xʒuopd
			PORT4.PDR.BYTE = (PORT4.PDR.BYTE & 0xf0) | T_posX_DDR;
			PORT4.PCR.BIT.B2 = 0;
			t_state++;
		} else {						//@^b`ȂȂ猟o0
			global_touch = 0;
			t_state = 0;
		}
		break;
	case 8:								//8FxôA-DRo[^N
		S12AD.ADANS0.WORD = 2;			//AN1 enable
		S12AD.ADCSR.BIT.ADST = 1;		//strat
		t_state++;
		break;
	case 9:								//9F^b`opd
		PORT4.PODR.BYTE = (PORT4.PODR.BYTE & 0xf0) | T_sense_DR;
		PORT4.PDR.BYTE = (PORT4.PDR.BYTE & 0xf0) | T_sense_DDR;
		PORT4.PCR.BIT.B2 = 1;
		t_state++;
		break;
	case 10:							//`^Ô߂̑҂
	case 11:
		t_state++;
		break;
	case 12:							//12F^b`mF
		if(PORT4.PIDR.BIT.B0 == ON){	//A-Dϊʂ荞
			global_touch = 1;
			global_inY = S12AD.ADDRB;
			global_inX = S12AD.ADDRA;
		}
		t_state = 0;
		break;
	default:
		t_state = 0;
		break;
	}
}

//xʒuvZ
int get_x(void)
{
	int x;
	x = ((global_inX - X_MIN) * SIZE_X) / (X_MAX - X_MIN) ;
	if(x <= 0) x = 1;
	if(x >= SIZE_X) x = SIZE_X - 1;
	return x;
}

//yʒuvZ
int get_y(void)
{
	int y;
	y = ((global_inY - Y_MIN) * SIZE_Y) / (Y_MAX - Y_MIN) ;
	if(y <= 0) y = 1;
	if(y >= SIZE_Y) y = SIZE_Y - 1;
	return y;
}

//^b`plp̓d
void set_idle(void){
	PORT4.PODR.BYTE = (PORT4.PODR.BYTE & 0xf0) | T_idle_DR;
	PORT4.PDR.BYTE = (PORT4.PDR.BYTE & 0xf0) | T_idle_DDR;
	PORT4.PCR.BIT.B2 = 0;
}

void chk_touch(void){
	PORT4.PODR.BYTE = (PORT4.PODR.BYTE & 0xf0) | T_sense_DR;
	PORT4.PDR.BYTE = (PORT4.PDR.BYTE & 0xf0) | T_sense_DDR;
	PORT4.PCR.BIT.B2 = 1;
}

unsigned char chk_sense(void){
	return PORT4.PIDR.BIT.B0;
}



void set_adc_x(void){
	PORT4.PODR.BYTE = (PORT4.PODR.BYTE & 0xf0) | T_posX_DR;
	PORT4.PDR.BYTE = (PORT4.PDR.BYTE & 0xf0) | T_posX_DDR;
}

unsigned short get_adc_x(void){
	S12AD.ADANS0.WORD = 2;		//AN1 enable
	S12AD.ADCSR.BIT.ADST = 1;	//strat
	while(!S12AD.ADCSR.BIT.ADST);
	return (S12AD.ADDRB);
}

void set_adc_y(void){
	PORT4.PODR.BYTE = (PORT4.PODR.BYTE & 0xf0) | T_posY_DR;
	PORT4.PDR.BYTE = (PORT4.PDR.BYTE & 0xf0) | T_posY_DDR;
}

unsigned short get_adc_y(void){
	S12AD.ADANS0.WORD = 1;		//AN0 enable
	S12AD.ADCSR.BIT.ADST = 1;	//strat
	while(!S12AD.ADCSR.BIT.ADST);
	return (S12AD.ADDRA);
}

